#version 120

#ifdef GL_ES
precision mediump float;
#endif

// audio
uniform sampler2D   u_tex0;
uniform vec2        u_tex0Resolution;

//video
uniform sampler2D   u_tex1;
#ifdef STREAMS_PREVS
uniform sampler2D   u_tex1Prev[STREAMS_PREVS];
#endif
uniform vec2        u_tex1Resolution;
uniform float       u_tex1Time;
uniform float       u_tex1Duration;
uniform float       u_tex1CurrentFrame;
uniform float       u_tex1TotalFrames;
uniform float       u_tex1Fps;

uniform vec2        u_resolution;

varying vec2        v_texcoord;

#define decimation(value, presicion) (floor(value * presicion)/presicion)

vec3 heatmap(float v) {
    vec3 r = v * 2.1 - vec3(1.8, 1.14, 0.3);
    return 1.0 - r * r;
}
// https://gist.github.com/983/e170a24ae8eba2cd174f
vec3 rgb2hsv(vec3 c)
{
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main (void) {
    vec4 color = vec4(vec3(0.0), 1.0);
    vec2 pixel = 1.0/u_resolution.xy;
    vec2 st = gl_FragCoord.xy * pixel;
    vec2 uv = v_texcoord;

    color = texture2D(u_tex1, st);
    
    #ifdef STREAMS_PREVS
    vec2 uv2 = uv * max(4.0, float(STREAMS_PREVS));
    vec2 uv2i = floor(uv2);
    vec2 uv2f = fract(uv2);

    if (uv2i.y == 0.0 && uv2i.x < float(STREAMS_PREVS) ) {
        int i = int(uv2i.x);
        color = texture2D( u_tex1Prev[i], uv2f);
    }
    #endif

    //color.rgb = mix( color.rgb, vec3(step(st.x, u_tex1Time/ u_tex1Duration), 0., 0.), step(st.y, 0.006) );
    //color.rgb = mix( color.rgb, vec3(step(st.x, u_tex1CurrentFrame/u_tex1TotalFrames), 0., 0.), step(st.y, 0.009) );
    //color.rgb = mix( color.rgb, vec3(step(st.x, fract(u_tex1CurrentFrame)), 0., 0.) , step(st.y, 0.003) );

    //gl_FragColor = color;

    vec3 hsvcolor = rgb2hsv(color.rgb);

    // audio
    vec3 color1 = vec3(0.0);
    float half_bar = 1./u_tex0Resolution.x;

    // fft
    //float bar = decimation(st.x, 25.);
    //float fft = texture2D(u_tex0, vec2(bar + half_bar, 0.5) ).r;
    //color1 += heatmap(bar) * step(st.y, fft);
    
    float k = 05;
    float fft = texture2D(u_tex0, vec2(hsvcolor.x, 0.5) ).r;

    //float a = 0.5*pow(2.0*((fft<0.5)?fft:1.0-fft), k);
    //fft = (fft<0.5)?a:1.0-fft;

    hsvcolor.x *= fft;

    gl_FragColor = vec4(hsv2rgb(hsvcolor), 1.0);
}
