
#ifdef GL_ES
precision mediump float;
#endif

uniform vec2 u_resolution;
uniform sampler2D u_tex0;
uniform float u_time;

uniform float my_float;

void main() {
    vec2 uv = gl_FragCoord.xy/u_resolution.xy;

    // Frequency.
    float fft = texture2D(u_tex0, vec2(uv.x, 0.)).x;

    // Volume.
    float vol = texture2D(u_tex0, vec2(uv.x, 0.)).y;


    float freqat = min(1.0, texture2D(u_tex0, vec2(my_float, 0.)).x);
    vec3 col = vec3(0.0, freqat, 0.0);
    col += 1.0 - smoothstep( 0.0, 0.010, abs(vol - uv.y) );
    col += 1.0 - smoothstep( 0.0, 0.030, abs(fft - uv.y) );
    
    if ((uv.x > my_float-0.005) && (uv.x < my_float+0.005)) {
        col = vec3(1.0);
    }

    //col = pow( col, vec3(1.0,0.5,2.0) );

    gl_FragColor = vec4(col,1.0);
}
