/**
  * This sketch demonstrates how to use the BeatDetect object song SOUND_ENERGY mode.<br />
  * You must call <code>detect</code> every frame and then you can use <code>isOnset</code>
  * to track the beat of the music.
  * <p>
  * This sketch plays an entire song, so it may be a little slow to load.
  * <p>
  * For more information about Minim and additional features, 
  * visit http://code.compartmental.net/minim/
  */
  
import ddf.minim.*;
import ddf.minim.analysis.*;

import oscP5.*;
import netP5.*;
OscP5 oscP5;
NetAddress remoteLoc;

Minim minim;
AudioInput audioIn;
BeatDetect beat;

float eRadius;

void setup()
{
  size(200, 200, P3D);
  minim = new Minim(this);
  audioIn = minim.getLineIn();

  // a beat detection object song SOUND_ENERGY mode with a sensitivity of 10 milliseconds
  beat = new BeatDetect();
  
  ellipseMode(RADIUS);
  eRadius = 20;
  
  oscP5 = new OscP5(this, 12000);
  remoteLoc = new NetAddress("127.0.0.1",8881);
}

void draw()
{
  background(0);
  beat.detect(audioIn.mix);
  float a = map(eRadius, 20, 80, 60, 255);
  fill(60, 255, 0, a);
  if ( beat.isOnset() ) eRadius = 80;
  ellipse(width/2, height/2, eRadius, eRadius);
  eRadius *= 0.95;
  if ( eRadius < 20 ) eRadius = 20;
  if(frameCount % 5 == 0) {
    OscMessage msg = new OscMessage("/osc_val_1");
    float x = map(eRadius,20,80,0.2,1.2);
    msg.add(x); //<>//
    oscP5.send(msg, remoteLoc);
  }
}
